# Release notes for cobrapy 0.22.0

## New features

- Add support for the OSQP and COIN-OR CBC solvers (#946)

## Fixes

- Fix the `Reaction.compartments` attribute not updating after metabolite changes (#1055)
- Lots of syntax, annotation, and docstring fixes (#1058, #1059, #1060, #1063,
  #1065, #1066, #1076, #1077, #1080)
- Multiprocessing on windows now sends data to processes via a pickle file which
  should speed up any multiprocessing initialization (#1070)
- Upgrade optlang and fix some tolerance issues (#1011)
- Enable Python 3.9 (#1082)

## Documentation

- Document boundary reactions (#1038)
- Documentation is now built again on each release (#1047)
- Clarify pfba in the documentation (#1049)

## Other

- COBRApy source code releases are now deposited on Zenodo which provides a
  citeable DOI (#1061)
- COBRApy creates automatic releases to BioSimulators (#1064)
- Fix deployment of releases to the website (#1068)
- Improve the `pyproject.toml` config (#1067)

## Backwards incompatible changes

- Remove some particular `cobra.Reaction.lower_bound` and `.upper_bound`
  behaviour that has been deprecated for a long time.
